"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GitReporterService = void 0;
var os_1 = require("os");
var tsyringe_1 = require("tsyringe");
var gitReporter_repository_1 = require("./gitReporter.repository");
var faker_1 = __importDefault(require("faker"));
var path_1 = __importDefault(require("path"));
var logger_1 = require("../logger");
var GitReporterService = /** @class */ (function () {
    function GitReporterService(repository, log) {
        this.repository = repository;
        this.log = log;
        this.gitLog = [];
    }
    GitReporterService_1 = GitReporterService;
    GitReporterService.prototype.generateReportForAllProjectsInADirectory = function (directoryPath, weeks) {
        return __awaiter(this, void 0, void 0, function () {
            var projectPaths;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.repository.readGitProjects(directoryPath)];
                    case 1:
                        projectPaths = _a.sent();
                        return [2 /*return*/, this.generateReport(projectPaths, weeks)];
                }
            });
        });
    };
    GitReporterService.prototype.generateAnonymousReportForAllProjectsInADirectory = function (directoryPath, weeks) {
        return __awaiter(this, void 0, void 0, function () {
            var projectPaths;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.repository.readGitProjects(directoryPath)];
                    case 1:
                        projectPaths = _a.sent();
                        return [2 /*return*/, this.generateAnonymousReport(projectPaths, weeks)];
                }
            });
        });
    };
    GitReporterService.prototype.generateReport = function (projectsPaths, weeks) {
        var e_1, _a;
        return __awaiter(this, void 0, void 0, function () {
            var _b, _c, gitLog, e_1_1, contributors;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 5, 6, 11]);
                        _b = __asyncValues(this.readGitLogs(projectsPaths, weeks));
                        _d.label = 1;
                    case 1: return [4 /*yield*/, _b.next()];
                    case 2:
                        if (!(_c = _d.sent(), !_c.done)) return [3 /*break*/, 4];
                        gitLog = _c.value;
                        this.addGitLog(gitLog);
                        _d.label = 3;
                    case 3: return [3 /*break*/, 1];
                    case 4: return [3 /*break*/, 11];
                    case 5:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 11];
                    case 6:
                        _d.trys.push([6, , 9, 10]);
                        if (!(_c && !_c.done && (_a = _b.return))) return [3 /*break*/, 8];
                        return [4 /*yield*/, _a.call(_b)];
                    case 7:
                        _d.sent();
                        _d.label = 8;
                    case 8: return [3 /*break*/, 10];
                    case 9:
                        if (e_1) throw e_1.error;
                        return [7 /*endfinally*/];
                    case 10: return [7 /*endfinally*/];
                    case 11:
                        contributors = this.gitLog.join(os_1.EOL).split(os_1.EOL.concat(os_1.EOL)).filter(Boolean);
                        return [2 /*return*/, {
                                weeks: weeks,
                                projects: projectsPaths.map(GitReporterService_1.extractProjectName),
                                totalCommits: contributors.length,
                                committers: GitReporterService_1.sortCommittersByTotalCommitsDesc(this.extractCommitters(contributors))
                            }];
                }
            });
        });
    };
    GitReporterService.prototype.generateAnonymousReport = function (projectsPaths, weeks) {
        return __awaiter(this, void 0, void 0, function () {
            var report;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.generateReport(projectsPaths, weeks)];
                    case 1:
                        report = _a.sent();
                        return [2 /*return*/, {
                                weeks: weeks,
                                projects: projectsPaths.map(function (projectPath) { return "    " + GitReporterService_1.extractProjectName(projectPath); }),
                                totalCommits: report.totalCommits,
                                committers: report.committers.map(function (committer) { return (__assign(__assign({}, committer), { email: faker_1.default.internet.email(), name: faker_1.default.name.findName() })); })
                            }];
                }
            });
        });
    };
    GitReporterService.prototype.addGitLog = function (gitLog) {
        this.gitLog.push(gitLog);
    };
    GitReporterService.prototype.readGitLogs = function (projectsPaths, weeks) {
        return __asyncGenerator(this, arguments, function readGitLogs_1() {
            var amountOfGitLogRead, projectsPaths_1, projectsPaths_1_1, projectPath, gitLog, e_2_1;
            var e_2, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        amountOfGitLogRead = 1;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 8, 9, 10]);
                        projectsPaths_1 = __values(projectsPaths), projectsPaths_1_1 = projectsPaths_1.next();
                        _b.label = 2;
                    case 2:
                        if (!!projectsPaths_1_1.done) return [3 /*break*/, 7];
                        projectPath = projectsPaths_1_1.value;
                        return [4 /*yield*/, __await(this.repository.readGitLog(projectPath, weeks))];
                    case 3:
                        gitLog = _b.sent();
                        this.log.info("(" + amountOfGitLogRead + "/" + projectsPaths.length + ") Read git log for " + projectPath);
                        amountOfGitLogRead += 1;
                        return [4 /*yield*/, __await(gitLog)];
                    case 4: return [4 /*yield*/, _b.sent()];
                    case 5:
                        _b.sent();
                        _b.label = 6;
                    case 6:
                        projectsPaths_1_1 = projectsPaths_1.next();
                        return [3 /*break*/, 2];
                    case 7: return [3 /*break*/, 10];
                    case 8:
                        e_2_1 = _b.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 10];
                    case 9:
                        try {
                            if (projectsPaths_1_1 && !projectsPaths_1_1.done && (_a = projectsPaths_1.return)) _a.call(projectsPaths_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 10: return [2 /*return*/];
                }
            });
        });
    };
    GitReporterService.prototype.extractCommitters = function (gitLogStats) {
        var contributorsCounter = gitLogStats.reduce(function (contributorsCounter, gitLogStat) {
            var _a;
            var _b, _c;
            var _d = __read(gitLogStat.split(os_1.EOL), 2), contributor = _d[0], stats = _d[1];
            return __assign(__assign({}, contributorsCounter), (_a = {}, _a[contributor] = {
                stats: __spread((((_b = contributorsCounter[contributor]) === null || _b === void 0 ? void 0 : _b.stats) || []), [stats]),
                totalCommits: (((_c = contributorsCounter[contributor]) === null || _c === void 0 ? void 0 : _c.totalCommits) || 0) + 1
            }, _a));
        }, {});
        return Object.entries(contributorsCounter).map(function (_a) {
            var _b = __read(_a, 2), contributor = _b[0], _c = _b[1], totalCommits = _c.totalCommits, stats = _c.stats;
            return (__assign(__assign(__assign({}, GitReporterService_1.extractContributorInfo(contributor)), GitReporterService_1.extractStats(stats)), { totalCommits: totalCommits }));
        });
    };
    GitReporterService.extractContributorInfo = function (contributor) {
        var _a = __read(contributor.split('|'), 2), name = _a[0], email = _a[1];
        return {
            name: String(name).trim(),
            email: String(email).trim()
        };
    };
    GitReporterService.extractStats = function (stats) {
        return stats.reduce(function (acc, stat) {
            var filesChanged = GitReporterService_1.parseStat(/\d* files? changed/, stat);
            var insertions = GitReporterService_1.parseStat(/\d* insertions?/, stat);
            var deletions = GitReporterService_1.parseStat(/\d* deletions?/, stat);
            return {
                totalFilesChanged: filesChanged + acc.totalFilesChanged,
                totalInsertions: insertions + acc.totalInsertions,
                totalDeletions: deletions + acc.totalDeletions
            };
        }, {
            totalFilesChanged: 0,
            totalInsertions: 0,
            totalDeletions: 0
        });
    };
    GitReporterService.parseStat = function (regExp, stat) {
        var extractedStat = regExp.exec(stat);
        if (extractedStat) {
            var _a = __read(/\d*/.exec(extractedStat[0]), 1), value = _a[0];
            return Number(value);
        }
        return 0;
    };
    GitReporterService.extractProjectName = function (projectPath) {
        var absolutePath = path_1.default.resolve(projectPath);
        return absolutePath.slice(absolutePath.lastIndexOf('/') + 1);
    };
    GitReporterService.sortCommittersByTotalCommitsDesc = function (committers) {
        return committers.sort(function (a, b) {
            return b.totalCommits - a.totalCommits || a.name.localeCompare(b.name);
        });
    };
    var GitReporterService_1;
    GitReporterService = GitReporterService_1 = __decorate([
        tsyringe_1.injectable(),
        __param(0, tsyringe_1.inject(gitReporter_repository_1.GitReporterRepository)),
        __param(1, tsyringe_1.inject(logger_1.Logger)),
        __metadata("design:paramtypes", [gitReporter_repository_1.GitReporterRepository,
            logger_1.Logger])
    ], GitReporterService);
    return GitReporterService;
}());
exports.GitReporterService = GitReporterService;
//# sourceMappingURL=gitReporter.service.js.map