"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.rawGitLog = exports.expectedReportOutput = exports.expectedReportForMultipleRepositories = exports.expectedReport = void 0;
exports.expectedReport = {
    weeks: 4,
    projects: ['irrelevant'],
    totalCommits: 13,
    committers: [
        {
            email: 'rtrott@gmail.com',
            name: 'Rich Trott',
            totalCommits: 6,
            totalFilesChanged: 16,
            totalInsertions: 84,
            totalDeletions: 15
        },
        {
            email: 'duhamelantoine1995@gmail.com',
            name: 'Antoine du Hamel',
            totalCommits: 1,
            totalFilesChanged: 1,
            totalInsertions: 2,
            totalDeletions: 2
        },
        {
            email: 'arnold.zokas@coderoom.net',
            name: 'Arnold Zokas',
            totalCommits: 1,
            totalFilesChanged: 1,
            totalInsertions: 12,
            totalDeletions: 0
        },
        {
            email: 'jasnell@gmail.com',
            name: 'James M Snell',
            totalCommits: 1,
            totalFilesChanged: 2,
            totalInsertions: 23,
            totalDeletions: 1
        },
        {
            email: 'luigipinca@gmail.com',
            name: 'Luigi Pinca',
            totalCommits: 1,
            totalFilesChanged: 2,
            totalInsertions: 24,
            totalDeletions: 20
        },
        {
            email: 'rafael.nunu@hotmail.com',
            name: 'Rafael Gonzaga',
            totalCommits: 1,
            totalFilesChanged: 1,
            totalInsertions: 1,
            totalDeletions: 0
        },
        {
            email: 'rod@vagg.org',
            name: 'Rod Vagg',
            totalCommits: 1,
            totalFilesChanged: 1,
            totalInsertions: 11,
            totalDeletions: 0
        },
        {
            email: 'sgallagh@redhat.com',
            name: 'Stephen Gallagher',
            totalCommits: 1,
            totalFilesChanged: 1,
            totalInsertions: 1,
            totalDeletions: 1
        }
    ]
};
exports.expectedReportForMultipleRepositories = __assign(__assign({}, exports.expectedReport), { projects: ['irrelevant', 'irrelevant'], totalCommits: exports.expectedReport.totalCommits * 2, committers: exports.expectedReport.committers.map(function (committer) { return ({
        email: committer.email,
        name: committer.name,
        totalCommits: committer.totalCommits * 2,
        totalFilesChanged: committer.totalFilesChanged * 2,
        totalInsertions: committer.totalInsertions * 2,
        totalDeletions: committer.totalDeletions * 2
    }); }) });
exports.expectedReportOutput = "\nReport for: \n    irrelevant\n\nTotal commits in the last 4 weeks: 13\nContributions by author:\n\n    Rich Trott (rtrott@gmail.com):\n      Commits: 6\n      Files changed: 16\n      Insertions: 84\n      Deletions: 15\n\n    Antoine du Hamel (duhamelantoine1995@gmail.com):\n      Commits: 1\n      Files changed: 1\n      Insertions: 2\n      Deletions: 2\n\n    Arnold Zokas (arnold.zokas@coderoom.net):\n      Commits: 1\n      Files changed: 1\n      Insertions: 12\n      Deletions: 0\n\n    James M Snell (jasnell@gmail.com):\n      Commits: 1\n      Files changed: 2\n      Insertions: 23\n      Deletions: 1\n\n    Luigi Pinca (luigipinca@gmail.com):\n      Commits: 1\n      Files changed: 2\n      Insertions: 24\n      Deletions: 20\n\n    Rafael Gonzaga (rafael.nunu@hotmail.com):\n      Commits: 1\n      Files changed: 1\n      Insertions: 1\n      Deletions: 0\n\n    Rod Vagg (rod@vagg.org):\n      Commits: 1\n      Files changed: 1\n      Insertions: 11\n      Deletions: 0\n\n    Stephen Gallagher (sgallagh@redhat.com):\n      Commits: 1\n      Files changed: 1\n      Insertions: 1\n      Deletions: 1\n";
exports.rawGitLog = "Arnold Zokas | arnold.zokas@coderoom.net\n 1 file changed, 12 insertions(+)\n\nLuigi Pinca | luigipinca@gmail.com\n 2 files changed, 24 insertions(+), 20 deletions(-)\n\nRich Trott | rtrott@gmail.com\n 1 file changed, 1 insertion(+), 1 deletion(-)\n\nRich Trott | rtrott@gmail.com\n 1 file changed, 1 insertion(+), 1 deletion(-)\n\nRich Trott | rtrott@gmail.com\n 2 files changed, 3 insertions(+), 3 deletions(-)\n\nRafael Gonzaga | rafael.nunu@hotmail.com\n 1 file changed, 1 insertion(+)\n\nJames M Snell | jasnell@gmail.com\n 2 files changed, 23 insertions(+), 1 deletion(-)\n\nRich Trott | rtrott@gmail.com\n 1 file changed, 0 insertions(+), 0 deletions(-)\n\nAntoine du Hamel | duhamelantoine1995@gmail.com\n 1 file changed, 2 insertions(+), 2 deletions(-)\n\nStephen Gallagher | sgallagh@redhat.com\n 1 file changed, 1 insertion(+), 1 deletion(-)\n\nRod Vagg | rod@vagg.org\n 1 file changed, 11 insertions(+)\n\nRich Trott | rtrott@gmail.com\n 5 files changed, 38 insertions(+), 5 deletions(-)\n\nRich Trott | rtrott@gmail.com\n 6 files changed, 41 insertions(+), 5 deletions(-)\n";
//# sourceMappingURL=fixture.js.map